# -*- coding: utf-8 -*-
from lista import *

# arbolGeneral: valor (any), hijos (lista)
estructura.crear("arbolGeneral", "valor hijos")

# Variables a usar en tests y ejemplos
hijosA11 = lista(arbolGeneral(111, None), lista(arbolGeneral(112, None), None))
a11 = arbolGeneral(11, hijosA11)

hijosA12 = lista(arbolGeneral(121, None), lista(arbolGeneral(122, None), lista(arbolGeneral(123, None), None)))
a12 = arbolGeneral(12, hijosA12)

hijosA13 = lista(arbolGeneral(131, None), None)
a13 = arbolGeneral(13, hijosA13)

hijosA14 = lista(arbolGeneral(141, None), lista(arbolGeneral(142, None), None))
a14 = arbolGeneral(14, hijosA14)

a1 = arbolGeneral(1, lista(a11, lista(a12, lista(a13, lista(a14, None)))))


# imprimirListaArboles: lista(arbolGeneral) -> None
# Imprime todos los árboles en la lista L, llamando a la función imprimir
def imprimirListaArboles(L):
    if L == None:
        return
    else:
        imprimir(cabeza(L))
        imprimirListaArboles(cola(L))


# imprimir: arbolGeneral -> None
# Imprime todos los nodos de ag en preorden. Para imprimir los hijos del árbol, utiliza la función imprimirListaArboles
def imprimir(ag):
    if ag == None:
        return
    else:
        imprimirListaArboles(ag.hijos)
        print ag.valor

# Descomentar la siguiente línea para imprimir
# imprimir(a1)

######################################################
# sumaListaArboles: lista(arbolGeneral) -> num
# Suma todos los valores en una lista de árboles
# Ejemplo: sumaListaArboles(hijosA11) entrega 223
def sumaListaArboles(L):
    if L == None:
        return 0
    else:
        s = suma(cabeza(L))
        return s + sumaListaArboles(cola(L))


# imprimir: arbolGeneral -> num
# Suma todos los valores en un árbol
# Ejemplo: suma(a11) entrega 234
def suma(ag):
    if ag == None:
        return 0
    else:
        s = sumaListaArboles(ag.hijos)
        return s + ag.valor

# El test de sumaListaArboles lo hacemos acá, pues si lo hiciéramos justo después de la definición de la función, tiraría error. Esto, porque en ese momento aún no hemos definido la función suma, y por ende, no la encontraría
assert sumaListaArboles(hijosA11) == 223
assert suma(a11) == 234













